SdFat: FatCache Class Reference

SdFat

Public Member Functions | Static Public Attributes | List of all members
FatCache Class Reference

Block cache. More...

`#include <FatVolume.h>`

## Public Member Functions
cache_t * | block ()
void | dirty ()
void | init (FatVolume *vol)
void | invalidate ()
bool | isDirty ()
uint32_t | lbn ()
cache_t * | read (uint32_t lbn, uint8_t option)
bool | sync ()

## Static Public Attributes
static const uint8_t | CACHE_FOR_READ = 0
static const uint8_t | CACHE_FOR_WRITE = CACHE_STATUS_DIRTY
static const uint8_t | CACHE_OPTION_NO_READ = 4
static const uint8_t | CACHE_RESERVE_FOR_WRITE = CACHE_STATUS_DIRTY | CACHE_OPTION_NO_READ
static const uint8_t | CACHE_STATUS_DIRTY = 1
static const uint8_t | CACHE_STATUS_MASK = CACHE_STATUS_DIRTY | CACHE_STATUS_MIRROR_FAT
static const uint8_t | CACHE_STATUS_MIRROR_FAT = 2

## Detailed Description

Block cache.

## Member Function Documentation

## ◆ block()

cache_t* FatCache::block | ( |  | ) |
| inline

Returns
  Cache block address.

## ◆ dirty()

void FatCache::dirty | ( |  | ) |
| inline

Set current block dirty.

## ◆ init()

void FatCache::init | ( | FatVolume * | vol | ) |
| inline

Initialize the cache.

Parameters

  [in] | vol | FatVolume that owns this FatCache.

## ◆ invalidate()

void FatCache::invalidate | ( |  | ) |
| inline

Invalidate current cache block.

## ◆ isDirty()

bool FatCache::isDirty | ( |  | ) |
| inline

Returns
  dirty status

## ◆ lbn()

uint32_t FatCache::lbn | ( |  | ) |
| inline

Returns
  Logical block number for cached block.

## ◆ read()

cache_t * FatCache::read | ( | uint32_t | lbn,
|  | uint8_t | option
| ) |  |

Read a block into the cache.

Parameters

  [in] | lbn | Block to read.
  [in] | option | mode for cached block.

Returns
  Address of cached block.

Copyright (c) 2011-2018 Bill Greiman This file is part of the SdFat library for SD memory cards.

MIT License

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

## ◆ sync()

bool FatCache::sync | ( |  | ) |

Write current block if dirty.

Returns
  true for success else false.

## Member Data Documentation

## ◆ CACHE_FOR_READ

const uint8_t FatCache::CACHE_FOR_READ = 0
| static

Cache block for read.

## ◆ CACHE_FOR_WRITE

const uint8_t FatCache::CACHE_FOR_WRITE = CACHE_STATUS_DIRTY
| static

Cache block for write.

## ◆ CACHE_OPTION_NO_READ

const uint8_t FatCache::CACHE_OPTION_NO_READ = 4
| static

Sync existing block but do not read new block.

## ◆ CACHE_RESERVE_FOR_WRITE

const uint8_t FatCache::CACHE_RESERVE_FOR_WRITE = CACHE_STATUS_DIRTY | CACHE_OPTION_NO_READ
| static

Reserve cache block for write - do not read from block device.

## ◆ CACHE_STATUS_DIRTY

const uint8_t FatCache::CACHE_STATUS_DIRTY = 1
| static

Cached block is dirty

## ◆ CACHE_STATUS_MASK

const uint8_t FatCache::CACHE_STATUS_MASK = CACHE_STATUS_DIRTY | CACHE_STATUS_MIRROR_FAT
| static

Cache block status bits

## ◆ CACHE_STATUS_MIRROR_FAT

const uint8_t FatCache::CACHE_STATUS_MIRROR_FAT = 2
| static

Cashed block is FAT entry and must be mirrored in second FAT.

The documentation for this class was generated from the following files:

- Arduino/libraries/SdFat/src/FatLib/FatVolume.h
- Arduino/libraries/SdFat/src/FatLib/FatVolume.cpp